//+------------------------------------------------------------------+
//Copyright  2005, MetaQuotes Software Corp.
//Upgrade by Vlad
// v. 1.0
//+------------------------------------------------------------------+
#property  copyright "Copyright  2005, MetaQuotes Software Corp. & Vlad 2010"
#property  link      "http://www.becemal.ru/mql/"
#property  indicator_separate_window
#property  indicator_buffers 2
#property  indicator_color1  LimeGreen
#property  indicator_color2  FireBrick
#property   indicator_width1  1
#property   indicator_width2  1
extern ENUM_TIMEFRAMES TimeFrame   = PERIOD_CURRENT;
extern int             RVIPeriod   = 10;
extern bool            Interpolate = true;
//---- indicator buffers
double     RVIBuffer[];
double     RVISignalBuffer[];
string indicatorFileName;
bool   returnBars;
int init()
  {
   SetIndexBuffer(0,RVIBuffer);
   SetIndexBuffer(1,RVISignalBuffer);
   SetIndexStyle(0,DRAW_LINE);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexDrawBegin(0,RVIPeriod+3);   
   SetIndexDrawBegin(1,RVIPeriod+7);     
   SetIndexLabel(0,"RVI");
   SetIndexLabel(1,"RVIS");
            indicatorFileName = WindowExpertName();
            returnBars        = TimeFrame==-99;
            TimeFrame         = MathMax(TimeFrame,_Period);
   IndicatorShortName(timeFrameToString(TimeFrame)+" KosherRVI("+RVIPeriod+")");
   return(0);
  }
int start()
  {
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
            if (returnBars) { RVIBuffer[0] = MathMin(limit+1,Bars-1); return(0); }
            if (TimeFrame != Period())
            {
               for(int i=limit; i>=0; i--)
               {
                  int y = iBarShift(NULL,TimeFrame,Time[i]);
                  RVIBuffer[i]       = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,RVIPeriod,0,y);
                  RVISignalBuffer[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,RVIPeriod,1,y);
                 
                  if (!Interpolate || (i>0 && y==iBarShift(NULL,TimeFrame,Time[i-1]))) continue;
                  
                  //
                  //
                  //
                  //
                  //
                  
                  int n,k; datetime time = iTime(NULL,TimeFrame,y);
                     for(n = 1; (i+n)<Bars && Time[i+n] >= time; n++) continue;	
                     for(k = 1; k<n && (i+n)<Bars && (i+k)<Bars; k++) 
                     {
                        RVIBuffer[i+k]       = RVIBuffer[i]       + (RVIBuffer[i+n]       - RVIBuffer[i]      ) * k/n;
                        RVISignalBuffer[i+k] = RVISignalBuffer[i] + (RVISignalBuffer[i+n] - RVISignalBuffer[i]) * k/n;
                     }                           
               }
               return(0);
            }

   //
   //
   //
   //
   //
   
   int j, nLimit,nCountedBars = IndicatorCounted();
   double dNum,dDeNum, Norm;
   if((Bars <= (RVIPeriod + 8)) || (nCountedBars < 0)) return(0);
   nLimit = Bars - RVIPeriod - 4;
   if(nCountedBars > (RVIPeriod + 4)) nLimit = Bars - nCountedBars;
   for(i=0; i <= nLimit; i++)
     {
      dNum=0.0; 
      dDeNum=0.0;
      for(k = 0; k < RVIPeriod; k++)
        {
         j = k + i;
         Norm = RVIPeriod - k + 1;
         dNum += Norm * ((Volume[j]*(Close[j] - Open[j])+8*Volume[j+1]*(Close[j+1]-Open[j+1])+8*Volume[j+2]*(Close[j+2]-Open[j+2])+Volume[j+3]*(Close[j+3]-Open[j+3])));
         dDeNum += Norm * ((Volume[j]*(High[j]-Low[j])+8*Volume[j+1]*(High[j+1]-Low[j+1])+8*Volume[j+2]*(High[j+2]-Low[j+2])+Volume[j+3]*(High[j+3]-Low[j+3])));
         }
      if(dDeNum!=0.0)   RVIBuffer[i] = dNum/dDeNum;
      else  RVIBuffer[i] = dNum;   
     }
   nLimit = Bars - RVIPeriod - 7;
   if(nCountedBars > (RVIPeriod+8)) nLimit = Bars - nCountedBars + 1;
   for(i=0; i<=nLimit; i++)   RVISignalBuffer[i] = (4*RVIBuffer[i] + 3*RVIBuffer[i+1] + 2*RVIBuffer[i+2] + RVIBuffer[i+3])/10;
   return(0);
  }
  
//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M10","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,10,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}  